#ifndef error_h
#define error_h

#include <string>

enum ErrorCode {
  Unknown       , //  0
  DivByZero     , //  1
  ExpLessZero   , //  2
  IndetExists   , //  3
  IndetNoLetter , //  4
  IndetNotExist , //  5
  IndetNotValid , //  6
  IndexRange    , //  7
  MatIdNotOne   , //  8
  MatNotSquare  , //  9
  MatSizeDiff   , // 10
  MonoLogLen    , // 11
  MonoNotValid  , // 12
  NoPrime       , // 13
  NotDiv        , // 14
  PolyDiffDeg   , // 15
  PolyManyIndet , // 16
  PolyNotHomo   , // 17
  TermNoAdd     , // 18
  VecSizeDiff   , // 19
  MatVecSizeDiff  // 20
};

enum ErrorLevel {
  ignore,
  warn  ,
  terminate
};

void Error_Execution(ErrorCode&, string&, string&, ErrorLevel&);
void Error          (ErrorCode , string , ErrorLevel level = terminate);

#endif

