#ifndef parser_h
#define parser_h

#include <string>
#include "contain.t"

extern bool          Parser_Quit;
extern char          Eval_Type  ;
extern istream       din        ;
extern ostream       dout       ;
extern unsigned long Exp_Depth  ;

bool         assignvariable(const string&,       string &      );
bool         deletevariable(const string&                      );
bool         display       (const string&                      );
int*         eval          (      string                       );
unsigned int evalfindstring(const string&, const string &      );
void         evaluate      (      string                       );
string       getbrackets   (      string&, const string &b = "");
string       getdefinition (      string&                      );
string       getfirstword  (      string&                      );
string       getindet      (      string&                      );
string       getnumber     (      string&                      );
string       getoperator   (      string&                      );
string       getpunctuation(      string&                      );
void         help          (      string                       );
string       readline      (                                   );
void         release       (const int*  &, const char   &      );
void         runprogram    (      string                       );
void         setting       (      string                       );
bool         setvar        (      string                       );
void         startparser   (                                   );
void         varlist       (                                   );


/***********************/
/* variable management */
/***********************/

struct variable {
  public:
    // standard constructor:
    variable();
    // general constructor:
    variable(const int   &                   );
    variable(const string&, const char&, int*);

    string name;
    char   type;
    int*   data;
};

extern list<variable> variables;

#endif
